#pragma once

#include <iostream>
#include <fstream>

class NewLearner
{
public:

	void initQ(bool model_, int civNum);
	void endGame();
	void QLearningStep(int pop, int land, int tech, int wonder);
	void QComputeFinal(int myScore, int yourScore, bool win);
	void randomize();

	NewLearner(void);
	~NewLearner(void);

private:

	static const int numStates=81;//2835;//405;//81;
	static const int numAct=4;

	const double alpha;
	const double gamma;
	const double eps;
	const double lambda;

	void Qmodel(int repeatNum);
	void initFile();
	int QArgMax(int s);
	int QEpsGreedy(int s);
	int chooseRandomS();
	int chooseRandomA(int s);
	int getSfromModel(int s, int a);
	void takeAction(int act);

	int s;
	int s_;
	int a;
	int a_;
	bool model;
	double lastDiff;
	const char * fileName;

	double QVal[numStates*numAct];
	double elig[numStates*numAct];
	double modelRew[numStates][numAct];
	double transProbs[numStates][numAct][numStates];
	double transFreq[numStates][numAct][numStates];
	double stateFreq[numStates][numAct];
	bool statesVisited[numStates];
	bool actionsTaken[numStates][numAct];
	int numActsTaken[numStates];
	int numStatesVisited;
	int numWin;
	int numPlayed;

	std::ifstream msrioIn; //for reading in
	std::ofstream msrioOut; //and writing out

};
