#pragma once

#include <iostream>
#include <fstream>

class NewLearnerFactored
{
public:
	
	void initQ(bool model_, int civNum);
	void endGame();
	void QLearningStep(int pop, int land, int tech, int wonder);
	void QComputeFinal(int myScore, int yourScore, bool win);

	NewLearnerFactored(void);
	~NewLearnerFactored(void);
	
private:

	static const int numStatesF=81;//2835;//405;//81;
	static const int numActF=4;

	const double alpha;
	const double gamma;
	const double eps;
	const double lambda;

	void randomize();
	void Qmodel(int repeatNum);
	void initFile();
	int QArgMax(int s);
	int QEpsGreedy(int s);
	int chooseRandomS();
	int chooseRandomA(int s);
	int getSfromModel(int s, int a);
	void takeAction(int act);

	const char * fileName;

	int s;
	int s_;
	int f1;
	int f2;
	int f3;
	int f4;
	int f5;
	int f6;
	int f1_;
	int f2_;
	int f3_;
	int f4_;
	int f5_;
	int f6_;
	int a;
	int a_;
	bool model;

	double QVal[numStatesF*numActF];
	double elig[numStatesF*numActF];
	double modelRew[numStatesF][numActF];
	//hard coded currently
	double transProbs[numStatesF][numActF][numStatesF];
	double transFreq1[numStatesF][numActF][3];
	double transFreq2[numStatesF][numActF][3];
	double transFreq3[numStatesF][numActF][3];
	double transFreq4[numStatesF][numActF][3];
	double transFreq5[numStatesF][numActF][5];
	double transFreq6[numStatesF][numActF][7];

	double stateFreq[numStatesF][numActF];
	bool statesVisited[numStatesF];
	bool actionsTaken[numStatesF][numActF];
	int numStatesFVisited;
	int numActFsTaken[numStatesF];
	int numWin;
	int numPlayed;
	int lastDiff;

	std::ifstream msrioInF; //for reading in
	std::ofstream msrioOutF; //and writing out

};
